/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiPlusFont.h
*
* Abstract:
*
*   Font related declarations
*
\**************************************************************************/

#ifndef _GDIPLUSFONT_H
#define _GDIPLUSFONT_H

#include "GdiPlusEnums.h"
#include "GdiPlusTypes.h"
#include "GdiPlusStubs.h"

typedef struct tagGp_Font
{
	GP_GPFONT * nativeFont;
	GpStatus lastResult;
}GP_FONT;


//----------------------------------------------------------------------------
// Font APIs
//----------------------------------------------------------------------------
GpStatus _stdcall GdipCreateFontFromDC(HDC hdc, GP_GPFONT **font);
GpStatus _stdcall GdipCreateFontFromLogfontA(HDC hdc, LOGFONTA *logfont, GP_GPFONT **font);
GpStatus _stdcall GdipCreateFontFromLogfontW(HDC hdc, LOGFONTW  *logfont, GP_GPFONT **font);
GpStatus _stdcall GdipCreateFont(GP_GPFONTFAMILY *fontFamily, REAL emSize, INT style, GpUnit unit, GP_GPFONT **font);
GpStatus _stdcall GdipCloneFont(GP_GPFONT* font, GP_GPFONT** cloneFont);
GpStatus _stdcall GdipDeleteFont(GP_GPFONT* font);
GpStatus _stdcall GdipGetFamily(GP_GPFONT *font, GP_GPFONTFAMILY **family);
GpStatus _stdcall GdipGetFontStyle(GP_GPFONT *font, INT *style);
GpStatus _stdcall GdipGetFontSize(GP_GPFONT *font, REAL *size);
GpStatus _stdcall GdipGetFontUnit(GP_GPFONT *font, GpUnit *unit);
GpStatus _stdcall GdipGetFontHeight(const GP_GPFONT *font, const GP_GPGRAPHICS *graphics, REAL *height);
GpStatus _stdcall GdipGetFontHeightGivenDPI(const GP_GPFONT *font, REAL dpi, REAL *height);
GpStatus _stdcall GdipGetLogFontA(GP_GPFONT * font, GP_GPGRAPHICS *graphics, LOGFONTA * logfontA);
GpStatus _stdcall GdipGetLogFontW(GP_GPFONT * font, GP_GPGRAPHICS *graphics, LOGFONTW * logfontW);
GpStatus _stdcall GdipNewInstalledFontCollection(GP_GPFONTCOLLECTION** fontCollection);
GpStatus _stdcall GdipNewPrivateFontCollection(GP_GPFONTCOLLECTION** fontCollection);
GpStatus _stdcall GdipDeletePrivateFontCollection(GP_GPFONTCOLLECTION** fontCollection);
GpStatus _stdcall GdipGetFontCollectionFamilyCount(GP_GPFONTCOLLECTION* fontCollection, INT * numFound);
GpStatus _stdcall GdipGetFontCollectionFamilyList(GP_GPFONTCOLLECTION* fontCollection, INT numSought, GP_GPFONTFAMILY* gpfamilies[],INT* numFound);

//---------------------------------------------------------
// GdiPlusLib.lib functions
//---------------------------------------------------------
GP_FONT GpFont_Font(GP_GPFONT* font, GpStatus status);
GP_FONT GpFont(HDC hdc);
GP_FONT GpFontHFont(HDC hdc, const HFONT hfont);
GP_FONT GpFontLOGFW(HDC hdc, LOGFONTW* logfont);
GP_FONT GpFontLOGFA(HDC hdc, LOGFONTA* logfont);
GP_FONT GpFontFam(const GP_FONTFAMILY * family, REAL emSize, INT style, GpUnit unit);
GpStatus GpFont_GetFamily(GP_FONT * this, GP_FONTFAMILY *family);
GP_FONT GpFontCOLL(const WCHAR * familyName, REAL emSize, INT style, GpUnit unit, const GP_FONTCOLLECTION * fontCollection);
GpStatus GpFont_GetLogFontA(GP_FONT * this, const GP_GRAPHICS *g, LOGFONTA *logfontA);
GpStatus GpFont_GetLogFontW(GP_FONT * this, const GP_GRAPHICS *g, LOGFONTW *logfontW);
GP_FONT GpFont_Clone(GP_FONT * this);
VOID GpFont_Delete(GP_FONT * this);
BOOL GpFont_IsAvailable(GP_FONT * this);
INT GpFont_GetStyle(GP_FONT * this);
REAL GpFont_GetSize(GP_FONT * this);
GpUnit GpFont_GetUnit(GP_FONT * this);
REAL GpFont_GetHeightGraph(GP_FONT * this, const GP_GRAPHICS *graphics);
REAL GpFont_GetHeight(GP_FONT * this, REAL dpi = 0);

#endif
