/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiplusFontFamily.h
*
* Abstract:
*
*   FontFamily related declarations
*
\**************************************************************************/

#ifndef _GDIP_FONT_FAMILY_H
#define _GDIP_FONT_FAMILY_H

#include "GdiPlusEnums.h"
#include "GdiPlusTypes.h"
#include "GdiPlusStubs.h"

typedef struct tagGp_FontCollection
{
	GP_GPFONTCOLLECTION * nativeFontCollection;
	GpStatus lastResult;
}GP_FONTCOLLECTION;


typedef struct tagGp_FontFamily
{
	GP_GPFONTFAMILY * nativeFamily;
	GpStatus lastResult;
}GP_FONTFAMILY;

typedef struct tagGp_PrivateFontCollection
{
    GP_GPFONTCOLLECTION *nativeFontCollection;
    GpStatus lastResult;
}GP_PRIVATEFONTCOLLECTION;

//----------------------------------------------------------------------------
// FontFamily
//----------------------------------------------------------------------------

GpStatus _stdcall GdipCreateFontFamilyFromName(const WCHAR *name, GP_GPFONTCOLLECTION *fontCollection, GP_GPFONTFAMILY **FontFamily);
GpStatus _stdcall GdipDeleteFontFamily(GP_GPFONTFAMILY *FontFamily);
GpStatus _stdcall GdipCloneFontFamily(GP_GPFONTFAMILY *FontFamily, GP_GPFONTFAMILY **clonedFontFamily);
GpStatus _stdcall GdipGetGenericFontFamilySansSerif(GP_GPFONTFAMILY **nativeFamily);
GpStatus _stdcall GdipGetGenericFontFamilySerif(GP_GPFONTFAMILY **nativeFamily);
GpStatus _stdcall GdipGetGenericFontFamilyMonospace(GP_GPFONTFAMILY **nativeFamily);
GpStatus _stdcall GdipGetFamilyName(const GP_GPFONTFAMILY  *family, WCHAR name[LF_FACESIZE], LANGID language);
GpStatus _stdcall GdipIsStyleAvailable(const GP_GPFONTFAMILY *family, INT style, BOOL * IsStyleAvailable);
GpStatus _stdcall GdipFontCollectionEnumerable(GP_GPFONTCOLLECTION* fontCollection, GP_GPGRAPHICS* graphics, INT * numFound);
GpStatus _stdcall GdipFontCollectionEnumerate(GP_GPFONTCOLLECTION* fontCollection,
    INT  numSought,GP_GPFONTFAMILY*   gpfamilies[], INT* numFound, GP_GPGRAPHICS* graphics);
GpStatus _stdcall GdipGetEmHeight(const GP_GPFONTFAMILY *family, INT style, UINT16 * EmHeight);
GpStatus _stdcall GdipGetCellAscent(const GP_GPFONTFAMILY *family, INT style, UINT16 * CellAscent);
GpStatus _stdcall GdipGetCellDescent(const GP_GPFONTFAMILY *family, INT style, UINT16 * CellDescent);
GpStatus _stdcall GdipGetLineSpacing(const GP_GPFONTFAMILY *family, INT style, UINT16 * LineSpacing);

//---------------------------------------------------------
// GdiPlusLib.lib functions
//---------------------------------------------------------
GP_FONTFAMILY GpFontFamily(VOID);
GP_FONTFAMILY GpFontFamily_Name(const WCHAR* name, const GP_FONTCOLLECTION* fontCollection);
GP_FONTFAMILY GpFontFamily_FontFamily(GP_GPFONTFAMILY *nativeOrig, GpStatus status);
const GP_FONTFAMILY * GpFontFamily_GenericSansSerif(VOID);
const GP_FONTFAMILY * GpFontFamily_GenericSerif(void);
const GP_FONTFAMILY * GpFontFamily_GenericMonospace(VOID);
void GpFontFamily_Delete(GP_FONTFAMILY * this);
GP_FONTFAMILY GpFontFamily_Clone(GP_FONTFAMILY * this);
GpStatus GpFontFamily_GetFamilyName(GP_FONTFAMILY * this, WCHAR name[LF_FACESIZE], LANGID language);
BOOL GpFontFamily_IsAvailable(const GP_FONTFAMILY* this);
BOOL GpFontFamily_IsStyleAvailable(GP_FONTFAMILY * this, INT style);
UINT16 GpFontFamily_GetEmHeight(GP_FONTFAMILY * this, INT style);
UINT16 GpFontFamily_GetCellAscent(GP_FONTFAMILY * this, INT style);
UINT16 GpFontFamily_GetCellDescent(GP_FONTFAMILY * this, INT style);
UINT16 GpFontFamily_GetLineSpacing(GP_FONTFAMILY * this, INT style);
GpStatus GpFontFamily_GetLastStatus(GP_FONTFAMILY * this);

#endif
