/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiPlusImaging.h
*
* Abstract:
*
*   GUIDs defined and used by the imaging library
*
\**************************************************************************/

#ifndef __REQUIRED_RPCNDR_H_VERSION__
#define __REQUIRED_RPCNDR_H_VERSION__ 475
#endif
#ifndef __RPC_H__
#include <rpc.h>
#endif
#ifndef __RPCNDR_H__
#include <rpcndr.h>
#endif
#ifndef __RPCNDR_H_VERSION__
#error <gdiplusimaging.h> requires an updated version of <rpcndr.h>
#endif
#ifndef COM_NO_WINDOWS_H
#ifndef _INC_WINDOWS
#include <windows.h>
#endif
#ifndef _OLE2_H_
#include <ole2.h>
#endif
#endif

#ifndef _GDIPLUSIMAGING_H
#define _GDIPLUSIMAGING_H

//---------------------------------------------------------------------------
// Image file format identifiers
//---------------------------------------------------------------------------
DEFINE_GUID(ImageFormatUndefined, 0xb96b3ca9,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatMemoryBMP, 0xb96b3caa,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatBMP, 0xb96b3cab,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatEMF, 0xb96b3cac,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatWMF, 0xb96b3cad,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatJPEG, 0xb96b3cae,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatPNG, 0xb96b3caf,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatGIF, 0xb96b3cb0,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatTIFF, 0xb96b3cb1,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatEXIF, 0xb96b3cb2,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(ImageFormatIcon, 0xb96b3cb5,0x0728,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);

//---------------------------------------------------------------------------
// Predefined multi-frame dimension IDs
//---------------------------------------------------------------------------
DEFINE_GUID(FrameDimensionTime, 0x6aedbd6d,0x3fb5,0x418a,0x83,0xa6,0x7f,0x45,0x22,0x9d,0xc8,0x72);
DEFINE_GUID(FrameDimensionResolution, 0x84236f7b,0x3bd3,0x428f,0x8d,0xab,0x4e,0xa1,0x43,0x9c,0xa3,0x15);
DEFINE_GUID(FrameDimensionPage, 0x7462dc86,0x6180,0x4c7e,0x8e,0x3f,0xee,0x73,0x33,0xa7,0xa4,0x83);

//---------------------------------------------------------------------------
// Property sets
//---------------------------------------------------------------------------
DEFINE_GUID(FormatIDImageInformation, 0xe5836cbe,0x5eef,0x4f1d,0xac,0xde,0xae,0x4c,0x43,0xb6,0x08,0xce);
DEFINE_GUID(FormatIDJpegAppHeaders, 0x1c4afdcd,0x6177,0x43cf,0xab,0xc7,0x5f,0x51,0xaf,0x39,0xee,0x85);

//---------------------------------------------------------------------------
// Encoder parameter sets
//---------------------------------------------------------------------------
DEFINE_GUID(EncoderCompression, 0xe09d739d,0xccd4,0x44ee,0x8e,0xba,0x3f,0xbf,0x8b,0xe4,0xfc,0x58);
DEFINE_GUID(EncoderColorDepth, 0x66087055,0xad66,0x4c7c,0x9a,0x18,0x38,0xa2,0x31,0x0b,0x83,0x37);
DEFINE_GUID(EncoderScanMethod, 0x3a4e2661,0x3109,0x4e56,0x85,0x36,0x42,0xc1,0x56,0xe7,0xdc,0xfa);
DEFINE_GUID(EncoderVersion, 0x24d18c76,0x814a,0x41a4,0xbf,0x53,0x1c,0x21,0x9c,0xcc,0xf7,0x97);
DEFINE_GUID(EncoderRenderMethod, 0x6d42c53a,0x229a,0x4825,0x8b,0xb7,0x5c,0x99,0xe2,0xb9,0xa8,0xb8);
DEFINE_GUID(EncoderQuality, 0x1d5be4b5,0xfa4a,0x452d,0x9c,0xdd,0x5d,0xb3,0x51,0x05,0xe7,0xeb);
DEFINE_GUID(EncoderTransformation,0x8d0eb2d1,0xa58e,0x4ea8,0xaa,0x14,0x10,0x80,0x74,0xb7,0xb6,0xf9);
DEFINE_GUID(EncoderLuminanceTable,0xedb33bce,0x0266,0x4a77,0xb9,0x04,0x27,0x21,0x60,0x99,0xe7,0x17);
DEFINE_GUID(EncoderChrominanceTable,0xf2e455dc,0x09b3,0x4316,0x82,0x60,0x67,0x6a,0xda,0x32,0x48,0x1c);
DEFINE_GUID(EncoderSaveFlag,0x292266fc,0xac40,0x47bf,0x8c, 0xfc, 0xa8, 0x5b, 0x89, 0xa6, 0x55, 0xde);

DEFINE_GUID(CodecIImageBytes,0x025d1823,0x6c7d,0x447b,0xbb, 0xdb, 0xa3, 0xcb, 0xc3, 0xdf, 0xa2, 0xfc);

#ifndef __IImageBytes_FWD_DEFINED__
#define __IImageBytes_FWD_DEFINED__
typedef interface IImageBytes IImageBytes;
#endif

#ifndef __IImageBytes_INTERFACE_DEFINED__
#define __IImageBytes_INTERFACE_DEFINED__

extern const IID IID_IImageBytes; // CodecIImageBytes
typedef struct IImageBytesVtbl {
  BEGIN_INTERFACE
	 HRESULT (_stdcall *QueryInterface)(IImageBytes *,REFIID,void * *);
	 ULONG (_stdcall *AddRef)(IImageBytes * );
	 ULONG (_stdcall *Release)(IImageBytes *);
	 HRESULT (_stdcall *CountBytes)(IImageBytes *, UINT *pcb);
	 HRESULT (_stdcall *LockBytes)(IImageBytes *, UINT cb,ULONG ulOffset, const VOID ** ppvBytes);
	 HRESULT (_stdcall *UnlockBytes)(IImageBytes *, const VOID *pvBytes, UINT cb, ULONG ulOffset);
  END_INTERFACE
}IImageBytesVtbl;

interface IImageBytes { CONST_VTBL struct IImageBytesVtbl *lpVtbl; };

#ifdef COBJMACROS
 #define IImageBytes_QueryInterface(a,b,c) (a)->lpVtbl->QueryInterface(a,b,c)
 #define IImageBytes_AddRef(a) (a)->lpVtbl->AddRef(a)
 #define IImageBytes_Release(a) (a)->lpVtbl->Release(a)
 #define IImageBytes_CountBytes(a,b) (a)->lpVtbl->CountBytes(a,b)
 #define IImageBytes_LockBytes(a,b,c,d) (a)->lpVtbl->LockBytes(a,b,c,d)
 #define IImageBytes_UnlockBytes(a,b,c,d) (a)->lpVtbl->UnlockBytes(a,b,c,d)
#endif

HRESULT _stdcall IImageBytes_QueryInterface_Proxy(IImageBytes *,REFIID,void * *);
ULONG   _stdcall IImageBytes_AddRef_Proxy(IImageBytes *);
ULONG   _stdcall IImageBytes_Release_Proxy(IImageBytes *);
HRESULT _stdcall IImageBytes_CountBytes_Proxy(IImageBytes *,UINT *pcb);
HRESULT _stdcall IImageBytes_LockBytes_Proxy(IImageBytes *,UINT cb,ULONG ulOffset, const VOID ** ppvBytes);
HRESULT _stdcall IImageBytes_UnlockBytes_Proxy(IImageBytes *, const VOID *pvBytes, UINT cb, ULONG ulOffset);

#endif


//--------------------------------------------------------------------------
// ImageCodecInfo structure
//--------------------------------------------------------------------------
typedef struct tagGpImageCodecInfo
{
    CLSID Clsid;
    GUID  FormatID;
    const WCHAR* CodecName;
    const WCHAR* DllName;
    const WCHAR* FormatDescription;
    const WCHAR* FilenameExtension;
    const WCHAR* MimeType;
    DWORD Flags;
    DWORD Version;
    DWORD SigCount;
    DWORD SigSize;
    const BYTE* SigPattern;
    const BYTE* SigMask;
}IMAGECODECINFO;

//--------------------------------------------------------------------------
// Information flags about image codecs
//--------------------------------------------------------------------------
typedef enum tagGpImageCodecFlags
{
    eImageCodecFlagsEncoder            = 0x00000001,
    eImageCodecFlagsDecoder            = 0x00000002,
    eImageCodecFlagsSupportBitmap      = 0x00000004,
    eImageCodecFlagsSupportVector      = 0x00000008,
    eImageCodecFlagsSeekableEncode     = 0x00000010,
    eImageCodecFlagsBlockingDecode     = 0x00000020,

    eImageCodecFlagsBuiltin            = 0x00010000,
    eImageCodecFlagsSystem             = 0x00020000,
    eImageCodecFlagsUser               = 0x00040000
}GpImageCodecFlags;

//---------------------------------------------------------------------------
// Access modes used when calling Image::LockBits
//---------------------------------------------------------------------------
typedef enum tagGpImageLockMode
{
    eImageLockModeRead        = 0x0001,
    eImageLockModeWrite       = 0x0002,
    eImageLockModeUserInputBuf= 0x0004
}GpImageLockMode;

//---------------------------------------------------------------------------
// Information about image pixel data
//---------------------------------------------------------------------------
typedef struct tagGpBitmapData
{
    UINT Width;
    UINT Height;
    INT Stride;
    GpPixelFormat GpPixelFormat;
    VOID* Scan0;
    UINT_PTR Reserved;
}BITMAPDATA;

//---------------------------------------------------------------------------
// Image flags
//---------------------------------------------------------------------------
typedef enum tagGpImageFlags
{
    eImageFlagsNone                = 0,

    // Low-word: shared with SINKFLAG_x

    eImageFlagsScalable            = 0x0001,
    eImageFlagsHasAlpha            = 0x0002,
    eImageFlagsHasTranslucent      = 0x0004,
    eImageFlagsPartiallyScalable   = 0x0008,

    // Low-word: color space definition

    eImageFlagsColorSpaceRGB       = 0x0010,
    eImageFlagsColorSpaceCMYK      = 0x0020,
    eImageFlagsColorSpaceGRAY      = 0x0040,
    eImageFlagsColorSpaceYCBCR     = 0x0080,
    eImageFlagsColorSpaceYCCK      = 0x0100,

    // Low-word: image size info

    eImageFlagsHasRealDPI          = 0x1000,
    eImageFlagsHasRealPixelSize    = 0x2000,

    // High-word

    eImageFlagsReadOnly            = 0x00010000,
    eImageFlagsCaching             = 0x00020000
}GpImageFlags;

typedef enum tagGpRotateFlipType
{
    eRotateNoneFlipNone = 0,
    eRotate90FlipNone   = 1,
    eRotate180FlipNone  = 2,
    eRotate270FlipNone  = 3,

    eRotateNoneFlipX    = 4,
    eRotate90FlipX      = 5,
    eRotate180FlipX     = 6,
    eRotate270FlipX     = 7,

    eRotateNoneFlipY    = eRotate180FlipX,
    eRotate90FlipY      = eRotate270FlipX,
    eRotate180FlipY     = eRotateNoneFlipX,
    eRotate270FlipY     = eRotate90FlipX,

    eRotateNoneFlipXY   = eRotate180FlipNone,
    eRotate90FlipXY     = eRotate270FlipNone,
    eRotate180FlipXY    = eRotateNoneFlipNone,
    eRotate270FlipXY    = eRotate90FlipNone
}GpRotateFlipType;

//---------------------------------------------------------------------------
// Encoder Parameter structure
//---------------------------------------------------------------------------
typedef struct tagGpEncoderParameter
{
    GUID    Guid;               // GUID of the parameter
    ULONG   NumberOfValues;     // Number of the parameter values
    ULONG   Type;               // Value type, like ValueTypeLONG  etc.
    VOID*   Value;              // A pointer to the parameter values
}ENCODERPARAMETER;

//---------------------------------------------------------------------------
// Encoder Parameters structure
//---------------------------------------------------------------------------
typedef struct tagGpEncoderParameters
{
    UINT Count;                      // Number of parameters in this structure
    ENCODERPARAMETER Parameter[1];   // Parameter values
}ENCODERPARAMETERS;

//---------------------------------------------------------------------------
// Property Item
//---------------------------------------------------------------------------
typedef struct tagGpPropertyItem
{
    PROPID  id;                 // ID of this property
    ULONG   length;             // Length of the property value, in bytes
    WORD    type;               // Type of the value, as one of TAG_TYPE_XXX
                                // defined above
    VOID*   value;              // property value
}PROPERTYITEM;


//---------------------------------------------------------------------------
// Image property types
//---------------------------------------------------------------------------
#define GpPropertyTagTypeByte        1
#define GpPropertyTagTypeASCII       2
#define GpPropertyTagTypeShort       3
#define GpPropertyTagTypeLong        4
#define GpPropertyTagTypeRational    5
#define GpPropertyTagTypeUndefined   7
#define GpPropertyTagTypeSLONG       9
#define GpPropertyTagTypeSRational  10

//---------------------------------------------------------------------------
// Image property ID tags
//---------------------------------------------------------------------------

#define GpPropertyTagExifIFD             0x8769
#define GpPropertyTagGpsIFD              0x8825

#define GpPropertyTagNewSubfileType      0x00FE
#define GpPropertyTagSubfileType         0x00FF
#define GpPropertyTagImageWidth          0x0100
#define GpPropertyTagImageHeight         0x0101
#define GpPropertyTagBitsPerSample       0x0102
#define GpPropertyTagCompression         0x0103
#define GpPropertyTagPhotometricInterp   0x0106
#define GpPropertyTagThreshHolding       0x0107
#define GpPropertyTagCellWidth           0x0108
#define GpPropertyTagCellHeight          0x0109
#define GpPropertyTagFillOrder           0x010A
#define GpPropertyTagDocumentName        0x010D
#define GpPropertyTagImageDescription    0x010E
#define GpPropertyTagEquipMake           0x010F
#define GpPropertyTagEquipModel          0x0110
#define GpPropertyTagStripOffsets        0x0111
#define GpPropertyTagOrientation         0x0112
#define GpPropertyTagSamplesPerPixel     0x0115
#define GpPropertyTagRowsPerStrip        0x0116
#define GpPropertyTagStripBytesCount     0x0117
#define GpPropertyTagMinSampleValue      0x0118
#define GpPropertyTagMaxSampleValue      0x0119
#define GpPropertyTagXResolution         0x011A   // Image resolution in width direction
#define GpPropertyTagYResolution         0x011B   // Image resolution in height direction
#define GpPropertyTagPlanarConfig        0x011C   // Image data arrangement
#define GpPropertyTagPageName            0x011D
#define GpPropertyTagXPosition           0x011E
#define GpPropertyTagYPosition           0x011F
#define GpPropertyTagFreeOffset          0x0120
#define GpPropertyTagFreeByteCounts      0x0121
#define GpPropertyTagGrayResponseUnit    0x0122
#define GpPropertyTagGrayResponseCurve   0x0123
#define GpPropertyTagT4Option            0x0124
#define GpPropertyTagT6Option            0x0125
#define GpPropertyTagResolutionUnit      0x0128   // Unit of X and Y resolution
#define GpPropertyTagPageNumber          0x0129
#define GpPropertyTagTransferFuncition   0x012D
#define GpPropertyTagSoftwareUsed        0x0131
#define GpPropertyTagDateTime            0x0132
#define GpPropertyTagArtist              0x013B
#define GpPropertyTagHostComputer        0x013C
#define GpPropertyTagPredictor           0x013D
#define GpPropertyTagWhitePoint          0x013E
#define GpPropertyTagPrimaryChromaticities 0x013F
#define GpPropertyTagColorMap            0x0140
#define GpPropertyTagHalftoneHints       0x0141
#define GpPropertyTagTileWidth           0x0142
#define GpPropertyTagTileLength          0x0143
#define GpPropertyTagTileOffset          0x0144
#define GpPropertyTagTileByteCounts      0x0145
#define GpPropertyTagInkSet              0x014C
#define GpPropertyTagInkNames            0x014D
#define GpPropertyTagNumberOfInks        0x014E
#define GpPropertyTagDotRange            0x0150
#define GpPropertyTagTargetPrinter       0x0151
#define GpPropertyTagExtraSamples        0x0152
#define GpPropertyTagSampleFormat        0x0153
#define GpPropertyTagSMinSampleValue     0x0154
#define GpPropertyTagSMaxSampleValue     0x0155
#define GpPropertyTagTransferRange       0x0156

#define GpPropertyTagJPEGProc            0x0200
#define GpPropertyTagJPEGInterFormat     0x0201
#define GpPropertyTagJPEGInterLength     0x0202
#define GpPropertyTagJPEGRestartInterval 0x0203
#define GpPropertyTagJPEGLosslessPredictors  0x0205
#define GpPropertyTagJPEGPointTransforms     0x0206
#define GpPropertyTagJPEGQTables         0x0207
#define GpPropertyTagJPEGDCTables        0x0208
#define GpPropertyTagJPEGACTables        0x0209

#define GpPropertyTagYCbCrCoefficients   0x0211
#define GpPropertyTagYCbCrSubsampling    0x0212
#define GpPropertyTagYCbCrPositioning    0x0213
#define GpPropertyTagREFBlackWhite       0x0214

#define GpPropertyTagICCProfile          0x8773   // This TAG is defined by ICC
                                                // for embedded ICC in TIFF
#define GpPropertyTagGamma               0x0301
#define GpPropertyTagICCProfileDescriptor 0x0302
#define GpPropertyTagSRGBRenderingIntent 0x0303

#define GpPropertyTagImageTitle          0x0320
#define GpPropertyTagCopyright           0x8298

// Extra TAGs (Like Adobe Image Information tags etc.)
#define GpPropertyTagResolutionXUnit           0x5001
#define GpPropertyTagResolutionYUnit           0x5002
#define GpPropertyTagResolutionXLengthUnit     0x5003
#define GpPropertyTagResolutionYLengthUnit     0x5004
#define GpPropertyTagPrintFlags                0x5005
#define GpPropertyTagPrintFlagsVersion         0x5006
#define GpPropertyTagPrintFlagsCrop            0x5007
#define GpPropertyTagPrintFlagsBleedWidth      0x5008
#define GpPropertyTagPrintFlagsBleedWidthScale 0x5009
#define GpPropertyTagHalftoneLPI               0x500A
#define GpPropertyTagHalftoneLPIUnit           0x500B
#define GpPropertyTagHalftoneDegree            0x500C
#define GpPropertyTagHalftoneShape             0x500D
#define GpPropertyTagHalftoneMisc              0x500E
#define GpPropertyTagHalftoneScreen            0x500F
#define GpPropertyTagJPEGQuality               0x5010
#define GpPropertyTagGridSize                  0x5011
#define GpPropertyTagThumbnailFormat           0x5012  // 1 = JPEG, 0 = RAW RGB
#define GpPropertyTagThumbnailWidth            0x5013
#define GpPropertyTagThumbnailHeight           0x5014
#define GpPropertyTagThumbnailColorDepth       0x5015
#define GpPropertyTagThumbnailPlanes           0x5016
#define GpPropertyTagThumbnailRawBytes         0x5017
#define GpPropertyTagThumbnailSize             0x5018
#define GpPropertyTagThumbnailCompressedSize   0x5019
#define GpPropertyTagColorTransferFunction     0x501A
#define GpPropertyTagThumbnailData             0x501B// RAW thumbnail bits in
                                                     // JPEG format or RGB format
                                                     // depends on
                                                     // PropertyTagThumbnailFormat

// Thumbnail related TAGs
#define GpPropertyTagThumbnailImageWidth       0x5020  // Thumbnail width
#define GpPropertyTagThumbnailImageHeight      0x5021  // Thumbnail height
#define GpPropertyTagThumbnailBitsPerSample    0x5022  // Number of bits per
                                                       // component
#define GpPropertyTagThumbnailCompression      0x5023  // Compression Scheme
#define GpPropertyTagThumbnailPhotometricInterp 0x5024 // Pixel composition
#define GpPropertyTagThumbnailImageDescription 0x5025  // Image Tile
#define GpPropertyTagThumbnailEquipMake        0x5026  // Manufacturer of Image
                                                       // Input equipment
#define GpPropertyTagThumbnailEquipModel       0x5027  // Model of Image input
                                                       // equipment
#define GpPropertyTagThumbnailStripOffsets     0x5028  // Image data location
#define GpPropertyTagThumbnailOrientation      0x5029  // Orientation of image
#define GpPropertyTagThumbnailSamplesPerPixel  0x502A  // Number of components
#define GpPropertyTagThumbnailRowsPerStrip     0x502B  // Number of rows per strip
#define GpPropertyTagThumbnailStripBytesCount  0x502C  // Bytes per compressed
                                                       // strip
#define GpPropertyTagThumbnailResolutionX      0x502D  // Resolution in width
                                                       // direction
#define GpPropertyTagThumbnailResolutionY      0x502E  // Resolution in height
                                                       // direction
#define GpPropertyTagThumbnailPlanarConfig     0x502F  // Image data arrangement
#define GpPropertyTagThumbnailResolutionUnit   0x5030  // Unit of X and Y
                                                       // Resolution
#define GpPropertyTagThumbnailTransferFunction 0x5031  // Transfer function
#define GpPropertyTagThumbnailSoftwareUsed     0x5032  // Software used
#define GpPropertyTagThumbnailDateTime         0x5033  // File change date and
                                                       // time
#define GpPropertyTagThumbnailArtist           0x5034  // Person who created the
                                                       // image
#define GpPropertyTagThumbnailWhitePoint       0x5035  // White point chromaticity
#define GpPropertyTagThumbnailPrimaryChromaticities 0x5036
                                                       // Chromaticities of
                                                       // primaries
#define GpPropertyTagThumbnailYCbCrCoefficients 0x5037 // Color space transforma-
                                                       // tion coefficients
#define GpPropertyTagThumbnailYCbCrSubsampling 0x5038  // Subsampling ratio of Y
                                                       // to C
#define GpPropertyTagThumbnailYCbCrPositioning 0x5039  // Y and C position
#define GpPropertyTagThumbnailRefBlackWhite    0x503A  // Pair of black and white
                                                       // reference values
#define GpPropertyTagThumbnailCopyRight        0x503B  // CopyRight holder

#define GpPropertyTagLuminanceTable            0x5090
#define GpPropertyTagChrominanceTable          0x5091

#define GpPropertyTagFrameDelay                0x5100
#define GpPropertyTagLoopCount                 0x5101

#define GpPropertyTagPixelUnit         0x5110  // Unit specifier for pixel/unit
#define GpPropertyTagPixelPerUnitX     0x5111  // Pixels per unit in X
#define GpPropertyTagPixelPerUnitY     0x5112  // Pixels per unit in Y
#define GpPropertyTagPaletteHistogram  0x5113  // Palette histogram

// EXIF specific tag
#define GpPropertyTagExifExposureTime  0x829A
#define GpPropertyTagExifFNumber       0x829D

#define GpPropertyTagExifExposureProg  0x8822
#define GpPropertyTagExifSpectralSense 0x8824
#define GpPropertyTagExifISOSpeed      0x8827
#define GpPropertyTagExifOECF          0x8828

#define GpPropertyTagExifVer            0x9000
#define GpPropertyTagExifDTOrig         0x9003 // Date & time of original
#define GpPropertyTagExifDTDigitized    0x9004 // Date & time of digital data generation

#define GpPropertyTagExifCompConfig     0x9101
#define GpPropertyTagExifCompBPP        0x9102

#define GpPropertyTagExifShutterSpeed   0x9201
#define GpPropertyTagExifAperture       0x9202
#define GpPropertyTagExifBrightness     0x9203
#define GpPropertyTagExifExposureBias   0x9204
#define GpPropertyTagExifMaxAperture    0x9205
#define GpPropertyTagExifSubjectDist    0x9206
#define GpPropertyTagExifMeteringMode   0x9207
#define GpPropertyTagExifLightSource    0x9208
#define GpPropertyTagExifFlash          0x9209
#define GpPropertyTagExifFocalLength    0x920A
#define GpPropertyTagExifMakerNote      0x927C
#define GpPropertyTagExifUserComment    0x9286
#define GpPropertyTagExifDTSubsec       0x9290  // Date & Time subseconds
#define GpPropertyTagExifDTOrigSS       0x9291  // Date & Time original subseconds
#define GpPropertyTagExifDTDigSS        0x9292  // Date & TIme digitized subseconds

#define GpPropertyTagExifFPXVer         0xA000
#define GpPropertyTagExifColorSpace     0xA001
#define GpPropertyTagExifPixXDim        0xA002
#define GpPropertyTagExifPixYDim        0xA003
#define GpPropertyTagExifRelatedWav     0xA004  // related sound file
#define GpPropertyTagExifInterop        0xA005
#define GpPropertyTagExifFlashEnergy    0xA20B
#define GpPropertyTagExifSpatialFR      0xA20C  // Spatial Frequency Response
#define GpPropertyTagExifFocalXRes      0xA20E  // Focal Plane X Resolution
#define GpPropertyTagExifFocalYRes      0xA20F  // Focal Plane Y Resolution
#define GpPropertyTagExifFocalResUnit   0xA210  // Focal Plane Resolution Unit
#define GpPropertyTagExifSubjectLoc     0xA214
#define GpPropertyTagExifExposureIndex  0xA215
#define GpPropertyTagExifSensingMethod  0xA217
#define GpPropertyTagExifFileSource     0xA300
#define GpPropertyTagExifSceneType      0xA301
#define GpPropertyTagExifCfaPattern     0xA302

#define GpPropertyTagGpsVer             0x0000
#define GpPropertyTagGpsLatitudeRef     0x0001
#define GpPropertyTagGpsLatitude        0x0002
#define GpPropertyTagGpsLongitudeRef    0x0003
#define GpPropertyTagGpsLongitude       0x0004
#define GpPropertyTagGpsAltitudeRef     0x0005
#define GpPropertyTagGpsAltitude        0x0006
#define GpPropertyTagGpsGpsTime         0x0007
#define GpPropertyTagGpsGpsSatellites   0x0008
#define GpPropertyTagGpsGpsStatus       0x0009
#define GpPropertyTagGpsGpsMeasureMode  0x00A
#define GpPropertyTagGpsGpsDop          0x000B  // Measurement precision
#define GpPropertyTagGpsSpeedRef        0x000C
#define GpPropertyTagGpsSpeed           0x000D
#define GpPropertyTagGpsTrackRef        0x000E
#define GpPropertyTagGpsTrack           0x000F
#define GpPropertyTagGpsImgDirRef       0x0010
#define GpPropertyTagGpsImgDir          0x0011
#define GpPropertyTagGpsMapDatum        0x0012
#define GpPropertyTagGpsDestLatRef      0x0013
#define GpPropertyTagGpsDestLat         0x0014
#define GpPropertyTagGpsDestLongRef     0x0015
#define GpPropertyTagGpsDestLong        0x0016
#define GpPropertyTagGpsDestBearRef     0x0017
#define GpPropertyTagGpsDestBear        0x0018
#define GpPropertyTagGpsDestDistRef     0x0019
#define GpPropertyTagGpsDestDist        0x001A

#endif // !_GDIPLUSIMAGING_H
