/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*    GdiplusLineCaps.h
*
* Abstract:
*
*   APIs for Custom Line Caps
*
\**************************************************************************/

#ifndef _GDIPLUSLINECAPS_H
#define _GDIPLUSLINECAPS_H

#include "GdiPlusEnums.h"
#include "GdiPlusStubs.h"
#include "GdiPlusTypes.h"

typedef struct tagGp_AdjustableArrowCap
{
    GP_GPADJUSTABLEARROWCAP* nativeCap;
    GpStatus lastResult;
}GP_ADJUSTABLEARROWCAP;

typedef struct tagGp_CustomLineCap
{
    GP_GPCUSTOMLINECAP * nativeCap;
    GpStatus lastResult;
}GP_CUSTOMLINECAP;


//----------------------------------------------------------------------------
// CustomLineCap methods
//----------------------------------------------------------------------------
GpStatus _stdcall GdipCreateCustomLineCap(GP_GPPATH* fillPath, GP_GPPATH* strokePath, GpLineCap baseCap, REAL baseInset, GP_GPCUSTOMLINECAP **customCap);
GpStatus _stdcall GdipDeleteCustomLineCap(GP_GPCUSTOMLINECAP* customCap);
GpStatus _stdcall GdipCloneCustomLineCap(GP_GPCUSTOMLINECAP* customCap, GP_GPCUSTOMLINECAP** clonedCap);
GpStatus _stdcall GdipGetCustomLineCapType(GP_GPCUSTOMLINECAP* customCap, GpCustomLineCapType* capType);
GpStatus _stdcall GdipSetCustomLineCapStrokeCaps(GP_GPCUSTOMLINECAP* customCap, GpLineCap startCap, GpLineCap endCap);
GpStatus _stdcall GdipGetCustomLineCapStrokeCaps(GP_GPCUSTOMLINECAP* customCap, GpLineCap* startCap, GpLineCap* endCap);
GpStatus _stdcall GdipSetCustomLineCapStrokeJoin(GP_GPCUSTOMLINECAP* customCap, GpLineJoin lineJoin);
GpStatus _stdcall GdipGetCustomLineCapStrokeJoin(GP_GPCUSTOMLINECAP* customCap, GpLineJoin* lineJoin);
GpStatus _stdcall GdipSetCustomLineCapBaseCap(GP_GPCUSTOMLINECAP* customCap, GpLineCap baseCap);
GpStatus _stdcall GdipGetCustomLineCapBaseCap(GP_GPCUSTOMLINECAP* customCap, GpLineCap* baseCap);
GpStatus _stdcall GdipSetCustomLineCapBaseInset(GP_GPCUSTOMLINECAP* customCap, REAL inset);
GpStatus _stdcall GdipGetCustomLineCapBaseInset(GP_GPCUSTOMLINECAP* customCap, REAL* inset);
GpStatus _stdcall GdipSetCustomLineCapWidthScale(GP_GPCUSTOMLINECAP* customCap, REAL widthScale);
GpStatus _stdcall GdipGetCustomLineCapWidthScale(GP_GPCUSTOMLINECAP* customCap, REAL* widthScale);

//----------------------------------------------------------------------------
// AdjustableArrowCap methods
//----------------------------------------------------------------------------
GpStatus _stdcall GdipCreateAdjustableArrowCap(REAL height, REAL width, BOOL isFilled, GP_GPADJUSTABLEARROWCAP **cap);
GpStatus _stdcall GdipSetAdjustableArrowCapHeight(GP_GPADJUSTABLEARROWCAP* cap, REAL height);
GpStatus _stdcall GdipGetAdjustableArrowCapHeight(GP_GPADJUSTABLEARROWCAP* cap, REAL* height);
GpStatus _stdcall GdipSetAdjustableArrowCapWidth(GP_GPADJUSTABLEARROWCAP* cap, REAL width);
GpStatus _stdcall GdipGetAdjustableArrowCapWidth(GP_GPADJUSTABLEARROWCAP* cap, REAL* width);
GpStatus _stdcall GdipSetAdjustableArrowCapMiddleInset(GP_GPADJUSTABLEARROWCAP* cap, REAL middleInset);
GpStatus _stdcall GdipGetAdjustableArrowCapMiddleInset(GP_GPADJUSTABLEARROWCAP* cap, REAL* middleInset);
GpStatus _stdcall GdipSetAdjustableArrowCapFillState(GP_GPADJUSTABLEARROWCAP* cap, BOOL fillState);
GpStatus _stdcall GdipGetAdjustableArrowCapFillState(GP_GPADJUSTABLEARROWCAP* cap, BOOL* fillState);

//////////////////////////////////
GP_CUSTOMLINECAP GpCustomLineCap(GP_GRAPHICSPATH* fillPath, GP_GRAPHICSPATH * strokePath, GpLineCap baseCap, REAL baseInset);
VOID      GpCustomLineCap_Delete(GP_CUSTOMLINECAP * this);
GpStatus  GpCustomLineCap_SetStrokeCaps(GP_CUSTOMLINECAP * this, GpLineCap startCap, GpLineCap endCap);
GpStatus  GpCustomLineCap_GetStrokeCaps(GP_CUSTOMLINECAP * this, GpLineCap* startCap, GpLineCap* endCap);
GpStatus  GpCustomLineCap_SetStrokeJoin(GP_CUSTOMLINECAP * this, GpLineJoin lineJoin);
GpLineJoin GpCustomLineCap_GetStrokeJoin(GP_CUSTOMLINECAP * this);
GpStatus GpCustomLineCap_SetBaseCap(GP_CUSTOMLINECAP * this, GpLineCap baseCap);
GpLineCap GpCustomLineCap_GetBaseCap(GP_CUSTOMLINECAP * this);
GpStatus GpCustomLineCap_SetBaseInset(GP_CUSTOMLINECAP * this, REAL inset);
REAL     GpCustomLineCap_GetBaseInset(GP_CUSTOMLINECAP * this);
GpStatus GpCustomLineCap_SetWidthScale(GP_CUSTOMLINECAP * this, REAL widthScale);
REAL     GpCustomLineCap_GetWidthScale(GP_CUSTOMLINECAP * this);
GP_CUSTOMLINECAP GpCustomLineCap_Clone(GP_CUSTOMLINECAP * this);
GP_ADJUSTABLEARROWCAP GpAdjustableArrowCap_AdjustableArrowCap(GP_GPADJUSTABLEARROWCAP* nativeCap,GpStatus status);
GP_ADJUSTABLEARROWCAP Gp_AdjustableArrowCap(REAL height, REAL width, BOOL isFilled = TRUE);
GpStatus GpAdjustableArrowCap_SetHeight(GP_ADJUSTABLEARROWCAP * this, REAL height);
REAL     GpAdjustableArrowCap_GetHeight(GP_ADJUSTABLEARROWCAP * this);
GpStatus GpAdjustableArrowCap_SetWidth(GP_ADJUSTABLEARROWCAP * this, REAL width);
REAL     GpAdjustableArrowCap_GetWidth(GP_ADJUSTABLEARROWCAP * this);
GpStatus GpAdjustableArrowCap_SetMiddleInset(GP_ADJUSTABLEARROWCAP * this,  REAL middleInset);
REAL     GpAdjustableArrowCap_GetMiddleInset(GP_ADJUSTABLEARROWCAP * this);
GpStatus GpAdjustableArrowCap_SetFillState(GP_ADJUSTABLEARROWCAP * this, BOOL isFilled);
BOOL     GpAdjustableArrowCap_IsFilled(GP_ADJUSTABLEARROWCAP * this);

#endif
