/**************************************************************************\
*
* All files in GdiPlusLib have been modified from the Microsoft
* GdiPlus C++ header files.
*
* Module Name:
*
*   GdiPlusPath.h
*
* Abstract:
*
*   Path related declarations
*
\**************************************************************************/

#ifndef _GDIPLUSPATH_H
#define _GDIPLUSPATH_H

#include "GdiPlusEnums.h"
#include "GdiPlusTypes.h"
#include "GdiPlusStubs.h"

typedef struct tagGp_PathData
{
    INT Count;
    POINTF * Points;
    BYTE * Types;
}GP_PATHDATA;

typedef struct tagGp_GraphicsPath
{
    GP_GPGRAPHICSPATH * nativePath;
    GpStatus  lastResult;
}GP_GRAPHICSPATH;

typedef struct tagGp_Path
{
    GP_GPPATH * nativePath;
    GpStatus  lastResult;
}GP_PATH;

typedef struct tagGp_GraphicsPathIterator
{
    GP_GPPATHITERATOR * nativeIterator;
    GpStatus lastResult;
}GP_GRAPHICSPATHITERATOR;

typedef struct tagGp_PathGradientBrush
{
	GP_GPPATHGRADIENTBRUSH * nativeBrush; //GpBrush
	GpStatus lastResult;
}GP_PATHGRADIENTBRUSH;

GpStatus _stdcall GdipCreatePath(GpFillMode brushMode, GP_GPPATH **path);
GpStatus _stdcall GdipCreatePath2(const GPPOINTF*, const BYTE*, INT, GpFillMode, GP_GPPATH **path);
GpStatus _stdcall GdipCreatePath2I(const GPPOINTI*, const BYTE*, INT, GpFillMode, GP_GPPATH **path);
GpStatus _stdcall GdipClonePath(GP_GPPATH* path, GP_GPPATH **clonePath);
GpStatus _stdcall GdipDeletePath(GP_GPPATH* path);
GpStatus _stdcall GdipResetPath(GP_GPPATH* path);
GpStatus _stdcall GdipGetPointCount(GP_GPPATH* path, INT* count);
GpStatus _stdcall GdipGetPathTypes(GP_GPPATH* path, BYTE* types, INT count);
GpStatus _stdcall GdipGetPathPoints(GP_GPPATH*, GPPOINTF* points, INT count);
GpStatus _stdcall GdipGetPathPointsI(GP_GPPATH*, GPPOINTI* points, INT count);
GpStatus _stdcall GdipGetPathFillMode(GP_GPPATH *path, GpFillMode *fillmode);
GpStatus _stdcall GdipSetPathFillMode(GP_GPPATH *path, GpFillMode fillmode);
GpStatus _stdcall GdipGetPathData(GP_GPPATH *path, GP_GPPATHDATA* pathData);
GpStatus _stdcall GdipStartPathFigure(GP_GPPATH *path);
GpStatus _stdcall GdipClosePathFigure(GP_GPPATH *path);
GpStatus _stdcall GdipClosePathFigures(GP_GPPATH *path);
GpStatus _stdcall GdipSetPathMarker(GP_GPPATH* path);
GpStatus _stdcall GdipClearPathMarkers(GP_GPPATH* path);
GpStatus _stdcall GdipReversePath(GP_GPPATH* path);
GpStatus _stdcall GdipGetPathLastPoint(GP_GPPATH* path, GPPOINTF* lastPoint);
GpStatus _stdcall GdipAddPathLine(GP_GPPATH *path, REAL x1, REAL y1, REAL x2, REAL y2);
GpStatus _stdcall GdipAddPathLine2(GP_GPPATH *path, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipAddPathArc(GP_GPPATH *path, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipAddPathBezier(GP_GPPATH *path, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
GpStatus _stdcall GdipAddPathBeziers(GP_GPPATH *path, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipAddPathCurve(GP_GPPATH *path, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipAddPathCurve2(GP_GPPATH *path, const GPPOINTF *points, INT count, REAL tension);
GpStatus _stdcall GdipAddPathCurve3(GP_GPPATH *path, const GPPOINTF *points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus _stdcall GdipAddPathClosedCurve(GP_GPPATH *path, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipAddPathClosedCurve2(GP_GPPATH *path, const GPPOINTF *points, INT count, REAL tension);
GpStatus _stdcall GdipAddPathRectangle(GP_GPPATH *path, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipAddPathRectangles(GP_GPPATH *path, const GPRECTF *rects, INT count);
GpStatus _stdcall GdipAddPathEllipse(GP_GPPATH *path, REAL x, REAL y, REAL width, REAL height);
GpStatus _stdcall GdipAddPathPie(GP_GPPATH *path, REAL x, REAL y, REAL width, REAL height,REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipAddPathPolygon(GP_GPPATH *path, const GPPOINTF *points, INT count);
GpStatus _stdcall GdipAddPathPath(GP_GPPATH *path, const GP_GPPATH* addingPath, BOOL connect);
GpStatus _stdcall GdipAddPathString(GP_GPPATH *path, const WCHAR *string, INT length, const GP_GPFONTFAMILY * family, INT style,  REAL emSize, const GPRECTF *layoutRect, const GP_GPSTRINGFORMAT *format);
GpStatus _stdcall GdipAddPathStringI(GP_GPPATH *path, const WCHAR *string, INT length, const GP_GPFONTFAMILY * family, INT style,REAL emSize, const RECTI *layoutRect, const GP_GPSTRINGFORMAT *format);
GpStatus _stdcall GdipAddPathLineI(GP_GPPATH *path, INT x1, INT y1, INT x2, INT y2);
GpStatus _stdcall GdipAddPathLine2I(GP_GPPATH *path, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipAddPathArcI(GP_GPPATH *path, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipAddPathBezierI(GP_GPPATH *path, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
GpStatus _stdcall GdipAddPathBeziersI(GP_GPPATH *path, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipAddPathCurveI(GP_GPPATH *path, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipAddPathCurve2I(GP_GPPATH *path, const GPPOINTI *points, INT count, REAL tension);
GpStatus _stdcall GdipAddPathCurve3I(GP_GPPATH *path, const GPPOINTI *points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus _stdcall GdipAddPathClosedCurveI(GP_GPPATH *path, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipAddPathClosedCurve2I(GP_GPPATH *path, const GPPOINTI *points, INT count, REAL tension);
GpStatus _stdcall GdipAddPathRectangleI(GP_GPPATH *path, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipAddPathRectanglesI(GP_GPPATH *path, const GPRECTI *rects, INT count);
GpStatus _stdcall GdipAddPathEllipseI(GP_GPPATH *path, INT x, INT y, INT width, INT height);
GpStatus _stdcall GdipAddPathPieI(GP_GPPATH *path, INT x, INT y, INT width, INT height,REAL startAngle, REAL sweepAngle);
GpStatus _stdcall GdipAddPathPolygonI(GP_GPPATH *path, const GPPOINTI *points, INT count);
GpStatus _stdcall GdipFlattenPath(GP_GPPATH *path, GP_GPMATRIX* matrix, REAL flatness);
GpStatus _stdcall GdipWindingModeOutline(GP_GPPATH *path, GP_GPMATRIX *matrix, REAL flatness);
GpStatus _stdcall GdipTransformPath(GP_GPPATH* path, GP_GPMATRIX* matrix);
GpStatus _stdcall GdipWidenPath(GP_GPPATH *nativePath, GP_GPPEN *pen, GP_GPMATRIX *matrix, REAL flatness);
GpStatus _stdcall GdipWarpPath(GP_GPPATH *path, GP_GPMATRIX* matrix,
            const GPPOINTF *points, INT count, REAL srcx, REAL srcy,
            REAL srcwidth, REAL srcheight, GpWarpMode warpMode, REAL flatness);


//----------------------------------------------------------------------------
// Path Enumeration methods
//----------------------------------------------------------------------------

GpStatus _stdcall GdipCreatePathIter(GP_GPPATHITERATOR **iterator, GP_GPPATH* path);
GpStatus _stdcall GdipDeletePathIter(GP_GPPATHITERATOR *iterator);
GpStatus _stdcall GdipPathIterNextSubpath(GP_GPPATHITERATOR* iterator, INT *resultCount,
        INT* startIndex, INT* endIndex, BOOL* isClosed);
GpStatus _stdcall GdipPathIterNextSubpathPath(GP_GPPATHITERATOR* iterator, INT* resultCount,
        GP_GPPATH* path, BOOL* isClosed);
GpStatus _stdcall GdipPathIterNextPathType(GP_GPPATHITERATOR* iterator, INT* resultCount,
        BYTE* pathType, INT* startIndex, INT* endIndex);
GpStatus _stdcall GdipPathIterNextMarker(GP_GPPATHITERATOR* iterator, INT *resultCount,
        INT* startIndex, INT* endIndex);
GpStatus _stdcall GdipPathIterNextMarkerPath(GP_GPPATHITERATOR* iterator, INT* resultCount, GP_GPPATH* path);
GpStatus _stdcall GdipPathIterGetCount(GP_GPPATHITERATOR* iterator, INT* count);
GpStatus _stdcall GdipPathIterGetSubpathCount(GP_GPPATHITERATOR* iterator, INT* count);
GpStatus _stdcall GdipPathIterIsValid(GP_GPPATHITERATOR* iterator, BOOL* valid);
GpStatus _stdcall GdipPathIterHasCurve(GP_GPPATHITERATOR* iterator, BOOL* hasCurve);
GpStatus _stdcall GdipPathIterRewind(GP_GPPATHITERATOR* iterator);
GpStatus _stdcall GdipPathIterEnumerate(GP_GPPATHITERATOR* iterator, INT* resultCount,
						    GPPOINTF *points, BYTE *types, INT count);
GpStatus _stdcall GdipPathIterCopyData(GP_GPPATHITERATOR* iterator, INT* resultCount,
						    GPPOINTF* points, BYTE* types, INT startIndex, INT endIndex);


//----------------------------------------------------------------------------
// PathGradient Brush
//----------------------------------------------------------------------------

GpStatus _stdcall GdipCreatePathGradient(const GPPOINTF* points,INT count, GpWrapMode wrapMode, GP_GPPATHGRADIENTBRUSH **polyGradient);
GpStatus _stdcall GdipCreatePathGradientI(const GPPOINTI* points, INT count, GpWrapMode wrapMode,GP_GPPATHGRADIENTBRUSH **polyGradient);
GpStatus _stdcall GdipCreatePathGradientFromPath(const GP_GPPATH* path, GP_GPPATHGRADIENTBRUSH **polyGradient);
GpStatus _stdcall GdipGetPathGradientCenterColor(GP_GPPATHGRADIENTBRUSH *brush, ARGB* colors);
GpStatus _stdcall GdipSetPathGradientCenterColor(GP_GPPATHGRADIENTBRUSH *brush, ARGB colors);
GpStatus _stdcall GdipGetPathGradientSurroundColorsWithCount(GP_GPPATHGRADIENTBRUSH *brush, ARGB* color, INT* count);
GpStatus _stdcall GdipSetPathGradientSurroundColorsWithCount(GP_GPPATHGRADIENTBRUSH *brush, const ARGB* color, INT* count);
GpStatus _stdcall GdipGetPathGradientPath(GP_GPPATHGRADIENTBRUSH *brush, GP_GPPATH *path);
GpStatus _stdcall GdipSetPathGradientPath(GP_GPPATHGRADIENTBRUSH *brush, const GP_GPPATH *path);
GpStatus _stdcall GdipGetPathGradientCenterPoint(GP_GPPATHGRADIENTBRUSH *brush, GPPOINTF* points);
GpStatus _stdcall GdipGetPathGradientCenterPointI(GP_GPPATHGRADIENTBRUSH *brush, GPPOINTI* points);
GpStatus _stdcall GdipSetPathGradientCenterPoint(GP_GPPATHGRADIENTBRUSH *brush, const GPPOINTF* points);
GpStatus _stdcall GdipSetPathGradientCenterPointI(GP_GPPATHGRADIENTBRUSH *brush, const GPPOINTI* points);
GpStatus _stdcall GdipGetPathGradientRect(GP_GPPATHGRADIENTBRUSH *brush, GPRECTF *rect);
GpStatus _stdcall GdipGetPathGradientRectI(GP_GPPATHGRADIENTBRUSH *brush, GPRECTI *rect);
GpStatus _stdcall GdipGetPathGradientPointCount(GP_GPPATHGRADIENTBRUSH *brush, INT* count);
GpStatus _stdcall GdipGetPathGradientSurroundColorCount(GP_GPPATHGRADIENTBRUSH *brush, INT* count);
GpStatus _stdcall GdipSetPathGradientGammaCorrection(GP_GPPATHGRADIENTBRUSH *brush, BOOL useGammaCorrection);
GpStatus _stdcall GdipGetPathGradientGammaCorrection(GP_GPPATHGRADIENTBRUSH *brush, BOOL *useGammaCorrection);
GpStatus _stdcall GdipGetPathGradientBlendCount(GP_GPPATHGRADIENTBRUSH *brush, INT *count);
GpStatus _stdcall GdipGetPathGradientBlend(GP_GPPATHGRADIENTBRUSH *brush, REAL *blend, REAL *positions, INT count);
GpStatus _stdcall GdipSetPathGradientBlend(GP_GPPATHGRADIENTBRUSH *brush, const REAL *blend, const REAL *positions, INT count);
GpStatus _stdcall GdipGetPathGradientPresetBlendCount(GP_GPPATHGRADIENTBRUSH *brush, INT *count);
GpStatus _stdcall GdipGetPathGradientPresetBlend(GP_GPPATHGRADIENTBRUSH *brush, ARGB *blend,REAL* positions, INT count);
GpStatus _stdcall GdipSetPathGradientPresetBlend(GP_GPPATHGRADIENTBRUSH *brush, const ARGB *blend, const REAL* positions, INT count);
GpStatus _stdcall GdipSetPathGradientSigmaBlend(GP_GPPATHGRADIENTBRUSH *brush, REAL focus, REAL scale);
GpStatus _stdcall GdipSetPathGradientLinearBlend(GP_GPPATHGRADIENTBRUSH *brush, REAL focus, REAL scale);
GpStatus _stdcall GdipGetPathGradientWrapMode(GP_GPPATHGRADIENTBRUSH *brush, GpWrapMode *wrapmode);
GpStatus _stdcall GdipSetPathGradientWrapMode(GP_GPPATHGRADIENTBRUSH *brush, GpWrapMode wrapmode);
GpStatus _stdcall GdipGetPathGradientTransform(GP_GPPATHGRADIENTBRUSH *brush, GP_GPMATRIX *matrix);
GpStatus _stdcall GdipSetPathGradientTransform(GP_GPPATHGRADIENTBRUSH *brush, GP_GPMATRIX *matrix);
GpStatus _stdcall GdipResetPathGradientTransform(GP_GPPATHGRADIENTBRUSH* brush);
GpStatus _stdcall GdipMultiplyPathGradientTransform(GP_GPPATHGRADIENTBRUSH* brush, const GP_GPMATRIX *matrix, GpMatrixOrder order);
GpStatus _stdcall GdipTranslatePathGradientTransform(GP_GPPATHGRADIENTBRUSH* brush, REAL dx, REAL dy, GpMatrixOrder order);
GpStatus _stdcall GdipScalePathGradientTransform(GP_GPPATHGRADIENTBRUSH* brush, REAL sx, REAL sy, GpMatrixOrder order);
GpStatus _stdcall GdipRotatePathGradientTransform(GP_GPPATHGRADIENTBRUSH* brush, REAL angle, GpMatrixOrder order);
GpStatus _stdcall GdipGetPathGradientFocusScales(GP_GPPATHGRADIENTBRUSH *brush, REAL* xScale, REAL* yScale);
GpStatus _stdcall GdipSetPathGradientFocusScales(GP_GPPATHGRADIENTBRUSH *brush, REAL xScale, REAL yScale);

//////////////////////////////////////////
GP_GRAPHICSPATH GpGraphicsPath(GpFillMode fillMode = eFillModeAlternate);
GP_GRAPHICSPATH GpGraphicsPath_2(const POINTF* points, const BYTE* types,INT count, GpFillMode fillMode = eFillModeAlternate);
GP_GRAPHICSPATH GpGraphicsPath_2I(const POINTI* points,  const BYTE* types, INT count, GpFillMode fillMode = eFillModeAlternate);
GP_GRAPHICSPATH GpGraphicsPath_Clone(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_Reset(GP_GRAPHICSPATH * this);
GpFillMode	GpGraphicsPath_GetFillMode(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_SetFillMode(GP_GRAPHICSPATH * this, GpFillMode fillmode);
INT 		GpGraphicsPath_GetPointCount(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_GetPathData(GP_GRAPHICSPATH * this, GP_PATHDATA* pathData);
GpStatus 	GpGraphicsPath_StartFigure(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_CloseFigure(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_CloseAllFigures( GP_GRAPHICSPATH * this );
GpStatus 	GpGraphicsPath_SetMarker(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_ClearMarkers(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_Reverse(GP_GRAPHICSPATH * this);
GpStatus 	GpGraphicsPath_GetLastPoint(GP_GRAPHICSPATH * this, POINTF* lastPoint);
GpStatus 	GpGraphicsPath_AddLine4F(GP_GRAPHICSPATH * this, REAL x1, REAL y1, REAL x2, REAL y2);
GpStatus 	GpGraphicsPath_AddLinePtsF(GP_GRAPHICSPATH * this,  const POINTF * pt1, const POINTF * pt2);
GpStatus 	GpGraphicsPath_AddLinesPtF(GP_GRAPHICSPATH * this, const POINTF* points, INT count);
GpStatus 	GpGraphicsPath_AddLine4I(GP_GRAPHICSPATH * this, INT x1, INT y1, INT x2, INT y2);
GpStatus 	GpGraphicsPath_AddLinePtI( GP_GRAPHICSPATH * this, const POINTI * pt1, const POINTI * pt2);
GpStatus 	GpGraphicsPath_AddLinesPtI(GP_GRAPHICSPATH * this, const POINTI* points, INT count);
GpStatus 	GpGraphicsPath_AddArc4F(GP_GRAPHICSPATH * this, REAL x, REAL y, REAL width,	REAL height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddArc(GP_GRAPHICSPATH * this, const RECTF * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddArc4I(GP_GRAPHICSPATH * this, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddArcRcI(GP_GRAPHICSPATH * this, const RECTI * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddBezier8F(GP_GRAPHICSPATH * this, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
GpStatus 	GpGraphicsPath_AddBezierPtsF( GP_GRAPHICSPATH * this, const POINTF * pt1, const POINTF * pt2, const POINTF * pt3, const POINTF * pt4);
GpStatus 	GpGraphicsPath_AddBeziersPtF(GP_GRAPHICSPATH * this, const POINTF* points, INT count);
GpStatus 	GpGraphicsPath_AddBezier8I(GP_GRAPHICSPATH * this, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
GpStatus 	GpGraphicsPath_AddBezier(GP_GRAPHICSPATH * this, const POINTI * pt1, const POINTI * pt2, const POINTI * pt3, const POINTI * pt4);
GpStatus 	GpGraphicsPath_AddBeziersI(GP_GRAPHICSPATH * this, const POINTI* points, INT count);
GpStatus 	GpGraphicsPath_AddCurveF(GP_GRAPHICSPATH * this, const POINTF* points, INT count);
GpStatus 	GpGraphicsPath_AddCurve2F(GP_GRAPHICSPATH * this, const POINTF* points, INT count, REAL tension);
GpStatus 	GpGraphicsPath_AddCurve3F( GP_GRAPHICSPATH * this, const POINTF* points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus 	GpGraphicsPath_AddCurveI( GP_GRAPHICSPATH * this, const POINTI* points, INT count);
GpStatus 	GpGraphicsPath_AddCurve2I(GP_GRAPHICSPATH * this, const POINTI* points, INT count, REAL tension);
GpStatus 	GpGraphicsPath_AddCurve3I(GP_GRAPHICSPATH * this, const POINTI* points, INT count, INT offset, INT numberOfSegments, REAL tension);
GpStatus 	GpGraphicsPath_AddClosedCurve( GP_GRAPHICSPATH * this, const POINTF* points, INT count);
GpStatus 	GpGraphicsPath_AddClosedCurve2( GP_GRAPHICSPATH * this, const POINTF* points, INT count, REAL tension );
GpStatus 	GpGraphicsPath_AddClosedCurveI( GP_GRAPHICSPATH * this, const POINTI* points, INT count);
GpStatus 	GpGraphicsPath_AddClosedCurve2I( GP_GRAPHICSPATH * this, const POINTI* points, INT count, REAL tension);
GpStatus 	GpGraphicsPath_AddRectangle(GP_GRAPHICSPATH * this, const RECTF * rect);
GpStatus 	GpGraphicsPath_AddRectangles(GP_GRAPHICSPATH * this, const RECTF* rects, INT count);
GpStatus 	GpGraphicsPath_AddRectangleRcI(GP_GRAPHICSPATH * this, const RECTI * rect);
GpStatus 	GpGraphicsPath_AddRectanglesRcsI(GP_GRAPHICSPATH * this, const RECTI* rects, INT count);
GpStatus 	GpGraphicsPath_AddEllipse4F( GP_GRAPHICSPATH * this, REAL x, REAL y, REAL width, REAL height);
GpStatus 	GpGraphicsPath_AddEllipseRcF( GP_GRAPHICSPATH * this,  const RECTF * rect);
GpStatus 	GpGraphicsPath_AddEllipse4I(GP_GRAPHICSPATH * this, INT x, INT y, INT width, INT height);
GpStatus 	GpGraphicsPath_AddEllipse( GP_GRAPHICSPATH * this, const RECTI * rect);
GpStatus 	GpGraphicsPath_AddPie4F(GP_GRAPHICSPATH * this, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddPieRcF(GP_GRAPHICSPATH * this, const RECTF * rect, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddPieI( GP_GRAPHICSPATH * this, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddPieRc( GP_GRAPHICSPATH * this, const RECTI * rect,REAL startAngle, REAL sweepAngle);
GpStatus 	GpGraphicsPath_AddPolygonF(GP_GRAPHICSPATH * this, const POINTF* points, INT count);
GpStatus 	GpGraphicsPath_AddPolygon(GP_GRAPHICSPATH * this, const POINTI* points, INT count);
GpStatus 	GpGraphicsPath_AddPath(GP_GRAPHICSPATH * this, const GP_GRAPHICSPATH* addingPath,  BOOL connect );
GpStatus 	GpGraphicsPath_AddStringPtF(GP_GRAPHICSPATH * this, const WCHAR *string, INT length, const GP_FONTFAMILY *family, INT style, REAL emSize, const POINTF * origin, const GP_STRINGFORMAT  *format);
GpStatus 	GpGraphicsPath_AddStringRcF(GP_GRAPHICSPATH * this, const WCHAR *string, INT length, const GP_FONTFAMILY *family, INT style, REAL emSize, const RECTF * layoutRect, const GP_STRINGFORMAT *format);
GpStatus 	GpGraphicsPath_AddStringPtI(GP_GRAPHICSPATH * this, const WCHAR *string, INT length, const GP_FONTFAMILY *family, INT style, REAL emSize, const POINTI * origin, const GP_STRINGFORMAT *format);
GpStatus 	GpGraphicsPath_AddStringRcI(GP_GRAPHICSPATH * this, const WCHAR *string, INT length, const GP_FONTFAMILY *family, INT style, REAL emSize, const RECTI * layoutRect, const GP_STRINGFORMAT *format);
GpStatus 	GpGraphicsPath_Transform(GP_GRAPHICSPATH * this, const GP_MATRIX* matrix);
GpStatus 	GpGraphicsPath_Flatten(GP_GRAPHICSPATH * this, const GP_MATRIX* matrix = NULL,  REAL flatness = 1.0f/4.0f);
GpStatus 	GpGraphicsPath_Widen(GP_GRAPHICSPATH * this, const GP_PEN* pen, const GP_MATRIX* matrix = NULL, REAL flatness = 1.0f/4.0f);
GpStatus 	GpGraphicsPath_Outline(GP_GRAPHICSPATH * this, const GP_MATRIX *matrix = NULL, REAL flatness = 1.0f/4.0f);
GpStatus 	GpGraphicsPath_Warp(GP_GRAPHICSPATH * this, const POINTF* destPoints,  INT count, const RECTF * srcRect, const GP_MATRIX* matrix = NULL, GpWarpMode warpMode = eWarpModePerspective, REAL flatness = 1.0f/4.0f);
GpStatus 	GpGraphicsPath_GetPathTypes(GP_GRAPHICSPATH * this, BYTE* types, INT count);
GpStatus 	GpGraphicsPath_GetPathPointsF(GP_GRAPHICSPATH * this, POINTF* points, INT count);
GpStatus 	GpGraphicsPath_GetPathPointsI(GP_GRAPHICSPATH * this, POINTI* points, INT count);
GpStatus 	GpGraphicsPath_GetLastStatus(GP_GRAPHICSPATH * this);
BOOL 		GpGraphicsPath_IsVisibleF(const GP_GRAPHICSPATH * this, const POINTF * point, GP_GRAPHICS* g);
BOOL 		GpGraphicsPath_IsVisibleI(const GP_GRAPHICSPATH * this, const POINTI * point, GP_GRAPHICS* g);
BOOL 		GpGraphicsPath_IsOutlineVisibleF(GP_GRAPHICSPATH * this, const POINTF * point, const GP_PEN* pen, const GP_GRAPHICS* g);
BOOL 		GpGraphicsPath_IsOutlineVisibleI(GP_GRAPHICSPATH * this, const POINTI * point,  const GP_PEN* pen, const GP_GRAPHICS* g = NULL);
GP_GRAPHICSPATH GpGraphicsPath_GraphicsPath(GP_GRAPHICSPATH * this);
GP_GRAPHICSPATHITERATOR GpGraphics_PathIterator(const GP_GRAPHICSPATH* path);
VOID 		GpGraphicsPathIterator_Delete(GP_GRAPHICSPATHITERATOR * this);
INT 		GpGraphicsPathIterator_NextSubpath(GP_GRAPHICSPATHITERATOR * this, INT* startIndex, INT* endIndex, BOOL* isClosed);
INT 		GpGraphicsPathIterator_NextSubpathGp(GP_GRAPHICSPATHITERATOR * this, const GP_GRAPHICSPATH* path, BOOL* isClosed);
INT 		GpGraphicsPathIterator_NextPathType(GP_GRAPHICSPATHITERATOR * this, BYTE* pathType, INT* startIndex, INT* endIndex);
INT 		GpGraphicsPathIterator_NextMarker(GP_GRAPHICSPATHITERATOR * this, INT* startIndex, INT* endIndex);
INT 		GpGraphicsPathIterator_NextMarkerGp(GP_GRAPHICSPATHITERATOR * this, const GP_GRAPHICSPATH* path);
INT 		GpGraphicsPathIterator_GetCount(GP_GRAPHICSPATHITERATOR * this);
INT 		GpGraphicsPathIterator_GetSubpathCount(GP_GRAPHICSPATHITERATOR * this);
BOOL 		GpGraphicsPathIterator_HasCurve(GP_GRAPHICSPATHITERATOR * this);
VOID 		GpGraphicsPathIterator_Rewind(GP_GRAPHICSPATHITERATOR * this);
INT 		GpGraphicsPathIterator_Enumerate(GP_GRAPHICSPATHITERATOR * this, POINTF *points, BYTE *types, INT count);
INT 		GpGraphicsPathIterator_CopyData( GP_GRAPHICSPATHITERATOR * this, POINTF* points, BYTE* types, INT startIndex, INT endIndex);
GpStatus 	GpGraphicsPathIterator_GetLastStatus(GP_GRAPHICSPATHITERATOR * this);
GP_BRUSH 	GpPathGradient_Brush(const POINTF* points, INT count, GpWrapMode wrapMode = eWrapModeClamp);
GP_PATHGRADIENTBRUSH GpPathGradient_BrushPtI(const POINTI* points, INT count, GpWrapMode wrapMode = eWrapModeClamp);
GP_PATHGRADIENTBRUSH GpPathGradientBrush(const GP_GRAPHICSPATH* path);
GpStatus 	GpPathGradientBrush_GetCenterColor(GP_PATHGRADIENTBRUSH * this, COLOR * color);
GpStatus 	GpPathGradientBrush_SetCenterColor(GP_PATHGRADIENTBRUSH * this, COLOR * color);
INT GpPathGradientBrush_GetPointCount(GP_PATHGRADIENTBRUSH * this);
INT GpPathGradientBrush_GetSurroundColorCount(GP_PATHGRADIENTBRUSH * this);
GpStatus 	GpPathGradientBrush_GetSurroundColors(GP_PATHGRADIENTBRUSH * this,  COLOR* colors, INT* count);
GpStatus 	GpPathGradientBrush_SetSurroundColors(GP_PATHGRADIENTBRUSH * this, const COLOR* colors, INT* count);
GpStatus 	GpPathGradientBrush_GetGraphicsPath(GP_PATHGRADIENTBRUSH * this, GP_GRAPHICSPATH* path);
GpStatus 	GpPathGradientBrush_SetGraphicsPath(GP_PATHGRADIENTBRUSH * this, GP_GRAPHICSPATH* path);
GpStatus 	GpPathGradientBrush_GetCenterPointF(GP_PATHGRADIENTBRUSH * this, POINTF* point);
GpStatus 	GpPathGradientBrush_GetCenterPointI(GP_PATHGRADIENTBRUSH * this, POINTI* point);
GpStatus 	GpPathGradientBrush_SetCenterPointF(GP_PATHGRADIENTBRUSH * this, const POINTF * point);
GpStatus 	GpPathGradientBrush_SetCenterPointI(GP_PATHGRADIENTBRUSH * this, const POINTI * point);
GpStatus 	GpPathGradientBrush_GetRectangleF(GP_PATHGRADIENTBRUSH * this, RECTF* rect);
GpStatus 	GpPathGradientBrush_GetRectangleI(GP_PATHGRADIENTBRUSH * this, RECTI* rect);
GpStatus 	GpPathGradientBrush_SetGammaCorrection(GP_PATHGRADIENTBRUSH * this, BOOL useGammaCorrection);
BOOL 		GpPathGradientBrush_GetGammaCorrection(GP_PATHGRADIENTBRUSH * this);
INT 		GpPathGradientBrush_GetBlendCount(GP_PATHGRADIENTBRUSH * this);
GpStatus 	GpPathGradientBrush_GetBlend(GP_PATHGRADIENTBRUSH * this, REAL* blendFactors, REAL* blendPositions, INT count);
GpStatus 	GpPathGradientBrush_SetBlend(GP_PATHGRADIENTBRUSH * this, const REAL* blendFactors, const REAL* blendPositions, INT count);
INT 		GpPathGradientBrush_GetInterpolationColorCount(GP_PATHGRADIENTBRUSH * this);
GpStatus 	GpPathGradientBrush_SetInterpolationColors(GP_PATHGRADIENTBRUSH * this, const COLOR* presetColors, const REAL* blendPositions, INT count);
GpStatus 	GpPathGradientBrush_GetInterpolationColors(GP_PATHGRADIENTBRUSH * this,COLOR* presetColors, REAL* blendPositions, INT count);
GpStatus 	GpPathGradientBrush_SetBlendBellShape(GP_PATHGRADIENTBRUSH * this, REAL focus, REAL scale = 1.0f);
GpStatus 	GpPathGradientBrush_SetBlendTriangularShape(GP_PATHGRADIENTBRUSH * this, REAL focus, REAL scale = 1.0f);
GpStatus 	GpPathGradientBrush_GetTransform(GP_PATHGRADIENTBRUSH * this, GP_MATRIX *matrix);
GpStatus 	GpPathGradientBrush_SetTransform(GP_PATHGRADIENTBRUSH * this, GP_MATRIX* matrix);
GpStatus 	GpPathGradientBrush_ResetTransform(GP_PATHGRADIENTBRUSH * this);
GpStatus 	GpPathGradientBrush_MultiplyTransform(GP_PATHGRADIENTBRUSH * this, GP_MATRIX* matrix, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpPathGradientBrush_TranslateTransform(GP_PATHGRADIENTBRUSH * this, REAL dx,REAL dy, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpPathGradientBrush_ScaleTransform(GP_PATHGRADIENTBRUSH * this, REAL sx, REAL sy, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpPathGradientBrush_RotateTransformM(GP_PATHGRADIENTBRUSH * this,REAL angle, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpPathGradientBrush_RotateTransformF(GP_PATHGRADIENTBRUSH * this, REAL angle, GpMatrixOrder order = eMatrixOrderPrepend);
GpStatus 	GpPathGradientBrush_GetFocusScales(GP_PATHGRADIENTBRUSH * this, REAL* xScale, REAL* yScale);
GpStatus 	GpPathGradientBrush_SetFocusScales(GP_PATHGRADIENTBRUSH * this, REAL xScale, REAL yScale);
GpWrapMode  GpPathGradientBrush_GetWrapMode(GP_PATHGRADIENTBRUSH * this);
GpStatus 	GpPathGradientBrush_SetWrapMode(GP_PATHGRADIENTBRUSH * this, GpWrapMode wrapMode);
VOID 		GpGraphicsPath_Delete(GP_GRAPHICSPATH * this);

#endif // !_GRAPHICSPATH_HPP
